// MKINITCPIO + UKI

use crate::{
    config::DriveConfig,
    linux::{arch_chroot, install_file},
    print_status,
};

pub fn setup_mkinitcpio(conf: &DriveConfig) {
    print_status("Writing /etc/mkinitcpio.d/linux.preset");
    install_file(
        "/mnt/etc/mkinitcpio.d/linux.preset",
        include_str!("../root/mkinitcpio/linux.preset"),
        0o644,
    );

    // Set kernel cmdline
    // TODO : Encryption support
    std::fs::create_dir_all("/mnt/etc/kernel").unwrap();
    std::fs::write("/mnt/etc/kernel/cmdline", format!("root={}", conf.root)).unwrap();

    // TODO : more configs
    print_status("Writing /etc/mkinitcpio.conf");
    install_file(
        "/mnt/etc/mkinitcpio.conf",
        include_str!("../root/mkinitcpio.conf"),
        0o644,
    );

    arch_chroot(&["mkinitcpio", "--allpresets"], None, true);
}
